"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.messages = exports.Message = exports.config = exports.commands = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

exports.help = help;
exports.usage = usage;

var _yargsParser = require("yargs-parser");

var _yargsParser2 = _interopRequireDefault(_yargsParser);

var _menhera = require("menhera");

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

var _config2 = require("./config");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var commands = exports.commands = {
  $: function $(_ref) {
    var _this = this;

    var _key = _ref._key,
        _val = _ref._val,
        cp = _ref.cp;
    var inject = this.inject,
        rootAlias = this.config.rootAlias;

    (0, _menhera.$set)(_val, inject);
    var name = _val.name,
        _val$args = _val.args,
        args = _val$args === undefined ? [] : _val$args,
        _val$desc = _val.desc,
        cDesc = _val$desc === undefined ? "" : _val$desc,
        _val$options = _val.options,
        options = _val$options === undefined ? {} : _val$options;

    var key = name || _key;

    this.commands[key] = _val;

    var commandOutput = [];
    args = args.map(function (argv) {
      return "[" + argv + "]";
    });
    if (key !== rootAlias) {
      commandOutput.push("" + (0, _utils.genOutput)({
        input: "" + key,
        chalkFn: _chalk2.default.magenta,
        length: 8,
        left: 2
      }) + (0, _utils.genOutput)({
        input: "" + args.join(" "),
        chalkFn: _chalk2.default.grey,
        length: 40
      }) + (0, _utils.genOutput)({
        input: "" + cDesc,
        chalkFn: _chalk2.default.grey,
        length: 10
      }) + "\n");
    }

    var optionOutput = [];
    (0, _menhera.$)(options, function (option, val) {
      var alias = val.alias,
          oDesc = val.desc;

      _this.options[option] = alias;
      _this.options[alias] = option;

      optionOutput.push("" + (0, _utils.genOutput)({
        input: "-" + alias,
        chalkFn: _chalk2.default.grey,
        length: 5,
        left: 10
      }) + (0, _utils.genOutput)({
        input: "--" + option,
        chalkFn: _chalk2.default.grey,
        length: 35
      }) + (0, _utils.genOutput)({
        input: oDesc,
        chalkFn: _chalk2.default.grey,
        length: 10
      }) + "\n");
    });

    (0, _menhera.$set)(this.helper, (0, _defineProperty3.default)({}, key, {
      optionOutput: optionOutput,
      commandOutput: commandOutput
    }));
  }
};

var config = {
  _: function _(_ref2) {
    var _ = _ref2._,
        _val = _ref2._val;

    (0, _menhera.$set)(this.config, _val);
  },
  start: function start(_ref3) {
    var _this2 = this;

    var _ = _ref3._,
        _val = _ref3._val;
    var _config = this.config,
        target = _config.target,
        rootAlias = _config.rootAlias;

    _.$use((0, _config2.Init)(this));

    var _parser = (0, _yargsParser2.default)(target || process.argv.slice(2)),
        __ = _parser._,
        options = (0, _objectWithoutProperties3.default)(_parser, ["_"]);

    var _2 = (0, _toArray3.default)(__),
        _$2 = _2[0],
        _key = _$2 === undefined ? rootAlias : _$2,
        _args = _2.slice(1);

    (0, _menhera.$)(options, function (key, val) {
      _this2.args[key] = val;
      var alias = _this2.options[key];
      if (alias) {
        _this2.args[alias] = val;
      }
    });

    var command = this.commands[_key];
    var _command$args = command.args,
        args = _command$args === undefined ? [] : _command$args;

    args.forEach(function (argv, i) {
      _this2.args[argv] = _args[i];
    });
    _args.forEach(function (argv, i) {
      _this2.args["$" + i] = _args[i];
    });

    var out = (0, _extends3.default)({ _: _ }, this, this.args, { _key: _key });
    var _command$execs = command.execs,
        execs = _command$execs === undefined ? {} : _command$execs;

    (0, _menhera.$)(execs, function (_key, val) {
      val(out);
    });
  }
};

exports.config = config;
function help(_ref4) {
  var _val = _ref4._val;

  var help = void 0;
  var rootAlias = this.config.rootAlias;

  if (_val !== rootAlias) {
    help = this.helper[_val];
  } else {
    help = {
      commandOutput: Object.values(this.helper).map(function (help) {
        return help.commandOutput;
      }),
      optionOutput: this.helper[rootAlias].optionOutput
    };
  }
  console.log("\n\n" + _chalk2.default.grey("Commands:") + "\n\n" + help.commandOutput.join("") + "\n\n" + _chalk2.default.grey("Options:") + "\n\n" + help.optionOutput.join("") + "\n    ");
}

function usage(_ref5) {
  var _val = _ref5._val;

  var help = this.helper[_val];
  help && console.log(" \n  \n" + _chalk2.default.grey("Usage:") + "\n              \n    " + help.commandOutput.join(""));
}

var Message = exports.Message = {
  $: function $(_ref6) {
    var _key = _ref6._key,
        _val = _ref6._val;

    var message = this.messages[_key][_val];
    if (typeof message === "function") {
      console.log(message(this));
    } else {
      console.log(message);
    }
  }
};

var messages = exports.messages = {
  _: function _(_ref7) {
    var _val = _ref7._val;

    Object.assign(this.messages, _val);
  }
};