"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.call = exports.config = exports.commands = exports.options = exports._prompts = undefined;

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _entries = require("babel-runtime/core-js/object/entries");

var _entries2 = _interopRequireDefault(_entries);

var _prompts2 = require("prompts");

var _prompts3 = _interopRequireDefault(_prompts2);

var _yargsParser = require("yargs-parser");

var _yargsParser2 = _interopRequireDefault(_yargsParser);

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isArray = Array.isArray;
var entries = _entries2.default;


var rootAlias = "_";
var commandRegex = /\.*[\][<>]/g;
var genSpace = function genSpace(space, fill) {
  return (0, _from2.default)(new Array(space - fill)).join(" ");
};
var useInit = {
  CLI: {
    options: {
      v: {
        alias: "version",
        desc: "version"
      },
      h: {
        alias: "help",
        desc: "help"
      }
    },
    commands: {
      _: {
        exec: function exec(_ref) {
          var v = _ref.v,
              version = _ref.CLI.config.version;

          v && console.log(version);
        }
      }
    }
  }
};

var _prompts = exports._prompts = {
  _: function _(_ref2) {
    var _this = this;

    var _ = _ref2._,
        _val = _ref2._val;
    var input = _val.input,
        then = _val.then;

    (0, _prompts3.default)(input).then(function (res) {
      return then({ res: res, _: _, CLI: _this });
    });
  }
};

var options = exports.options = {
  _: function _(_ref3) {
    var _key = _ref3._key,
        _val = _ref3._val,
        cp = _ref3.cp;

    (0, _assign2.default)(this.options, _val);
  },
  $: function $(_ref4) {
    var _key = _ref4._key,
        _val = _ref4._val,
        cp = _ref4.cp;
    var alias = _val.alias,
        desc = _val.desc;

    var keyLength = _key.length;
    var aliasLength = alias.length;
    var output = "  -" + _chalk2.default.grey(_key) + genSpace(8, keyLength) + "--" + _chalk2.default.grey(alias) + genSpace(28, aliasLength) + _chalk2.default.grey(desc) + "\n";
    this.sugar.optionList.push(output);
  }
};

var commands = exports.commands = {
  $: function $(_ref5) {
    var _key = _ref5._key,
        _val = _ref5._val,
        cp = _ref5.cp;
    var name = _val.name,
        exec = _val.exec,
        _val$args = _val.args,
        args = _val$args === undefined ? [] : _val$args,
        desc = _val.desc;

    var key = name || _key;

    this.commands[key] = _val;
    this.Event.on(key, exec);
    if (key !== rootAlias) {
      args = args.map(function (argv) {
        return "[" + argv + "]";
      });
      var keyLength = key.length;
      var argsLength = args.join(" ").length;
      var output = "  " + _chalk2.default.magenta(key) + genSpace(8, keyLength) + _chalk2.default.gray(args.join(" ")) + genSpace(30, argsLength) + " " + _chalk2.default.grey(desc) + " \n";
      this.sugar.commandList.push(output);
    }
  }
};

var config = {
  _: function _(_ref6) {
    var _val = _ref6._val;

    (0, _assign2.default)(this.config, _val);
  },
  start: function start(_ref7) {
    var _this2 = this;

    var _ = _ref7._,
        _val = _ref7._val;
    var target = this.config.target;

    _.$use(useInit);

    var _parser = (0, _yargsParser2.default)(target || process.argv.slice(2)),
        __ = _parser._,
        options = (0, _objectWithoutProperties3.default)(_parser, ["_"]);

    var _2 = (0, _toArray3.default)(__),
        _$ = _2[0],
        _key = _$ === undefined ? rootAlias : _$,
        _args = _2.slice(1);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(entries(options)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ref8 = _step.value;

        var _ref9 = (0, _slicedToArray3.default)(_ref8, 2);

        var key = _ref9[0];
        var val = _ref9[1];

        this.args[key] = val;

        var _ref11 = this.options[key] || {},
            alias = _ref11.alias;

        if (alias) {
          this.args[alias] = val;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    var _ref10 = this.commands[_key] || {},
        _ref10$args = _ref10.args,
        args = _ref10$args === undefined ? [] : _ref10$args;

    args.forEach(function (argv, i) {
      _this2.args[argv] = _args[i];
    });
    this.Event.emit(_key, (0, _extends3.default)({ _: _, CLI: this }, this.args));
  }
};

exports.config = config;
var call = exports.call = {
  help: function help(_ref12) {
    var _val = _ref12._val;

    console.log("\n" + _chalk2.default.grey("Commands:") + "\n\n" + this.sugar.commandList.join("") + "\n\n" + _chalk2.default.grey("Options:") + "\n\n" + this.sugar.optionList.join("") + "\n    ");
  }
};