"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = exports._ = undefined;

var _fsExtra = require("fs-extra");

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _chalk = require("chalk");

var _chalk2 = _interopRequireDefault(_chalk);

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _ = exports._ = {
  exec: function exec(_ref) {
    var _ = _ref._,
        h = _ref.h;

    _.$use({
      CLI: {
        call: {
          help: true
        }
      }
    });
  }
};

var init = exports.init = {
  desc: "init with template",
  args: ["projectName"],
  exec: function exec(_ref2) {
    var _ = _ref2._,
        _ref2$projectName = _ref2.projectName,
        projectName = _ref2$projectName === undefined ? "my-project" : _ref2$projectName,
        templatePath = _ref2.CLI.config.templatePath;

    var realTemplatePath = templatePath;
    var templates = _fsExtra2.default.readdirSync(realTemplatePath);
    var TemplateChoices = templates.map(function (template) {
      return { title: template, value: template };
    });

    _.$use({
      CLI: {
        prompts: {
          input: {
            type: "select",
            name: "template",
            message: "select a template",
            choices: TemplateChoices
          },
          then: function then(_ref3) {
            var template = _ref3.res.template;

            var finalTemplatePath = (0, _path.join)(realTemplatePath, template);
            var finalProjectPath = (0, _path.join)(process.cwd(), projectName);
            _fsExtra2.default.copySync(finalTemplatePath, finalProjectPath);
            console.log(_chalk2.default.green("\nSuccess! Created <" + projectName + "> with template <" + template + ">\n\nWe suggest that you begin by typing:\n  $ cd " + projectName + "\n  $ yarn install\n  \nWhen you installed dependencies that you can typing:\n  $ yarn start\n  $ yarn run dev\n\n  Happy hacking!\n"));
          }
        }
      }
    });
  }
};